local SUF = AceLibrary("AceAddon-2.0"):new("AceModuleCore-2.0", "AceDB-2.0", "AceConsole-2.0")


--[[
	CopyTable(into, from) : Updates 'into' with the vaues in 'from'
	- Deep copy the table
	- Copy key to value for the case: "key" = true
--]]
local function CopyTable(into, from)
	for key, val in pairs(from) do
		if( type(val) == "table" ) then
			if not into[key] then into[key] = {} end
			CopyTable(into[key], val)
		else
			if val == true then
				into[key] = key
			else
				into[key] = val
			end
		end
	end
	return into
end

SUF.CopyTable = CopyTable

function SUF:OnInitialize()

	self:RegisterDB("SimpleUnitFramesDB", "SimpleUnitFramesDBPerChar")

	local consoleOptions = {
		type = 'group',
		args = {}
	}

	self:RegisterChatCommand( { '/suf' }, consoleOptions )
	
	-- This only works after RegisterChatCommand().
	consoleOptions.args.standby = nil
	
	self.consoleOptions = consoleOptions
	
end

function SUF:OnEnable()

end

function SUF:OnDisable()
	for name, module in self:IterateModules() do
		if module.OnDisable then
			module:OnDisable()
		end
	end
end

-- Save the table as base locales if there isn't one, update the current locales if there is one.
function SUF:UpdateLocales(loc)
	if not self.loc then
		self.loc = {}
	end
	CopyTable(self.loc, loc)
end


setglobal('SimpleUnitFrames', SUF)