TargetBuffs = AceLibrary("AceAddon-2.0"):new()

function TargetBuffs:OnEnable()
	MAX_TARGET_BUFFS = 16
	local hook = function() self:Adjust() end
	hooksecurefunc("TargetDebuffButton_Update", hook)
end

function TargetBuffs:Count()
	local i = 0
	while UnitBuff("target", i + 1) do
		i = i + 1
	end
	return i
end

function TargetBuffs:ResizeOriginals(size)
	for i=1, 5 do
		local button = getglobal("TargetFrameBuff" .. i)
		if button then
			button:SetWidth(size)
			button:SetHeight(size)
		end
	end
	for i=1, 6 do
		local button = getglobal("TargetFrameDebuff" .. i)
		local frame = getglobal("TargetFrameDebuff" .. i .. "Border")
		if button then
			button:SetWidth(size)
			button:SetHeight(size)
		end
		if frame then
			frame:SetWidth(size + 2)
			frame:SetHeight(size + 2)
		end
	end
end

function TargetBuffs:Adjust()
	if UnitIsFriend("player", "target") then
		local buffs = self:Count()
		-- buffs up to 5 are handled by the standard Blizzard code
		if buffs > 5 then
			self:ResizeOriginals(17)
			TargetFrameBuff6:ClearAllPoints()
			TargetFrameBuff7:ClearAllPoints()
			TargetFrameBuff11:ClearAllPoints()
			TargetFrameDebuff1:ClearAllPoints()
			if TargetofTargetFrame:IsShown() then
				-- 5/5/6 buff layout
				TargetFrameBuff6:SetPoint("TOPLEFT", "TargetFrameBuff1", "BOTTOMLEFT", 0, -2)
				TargetFrameBuff7:SetPoint("LEFT", "TargetFrameBuff6", "RIGHT", 3, 0)
				TargetFrameBuff11:SetPoint("TOPLEFT", "TargetFrameBuff6", "BOTTOMLEFT", 0, -2)
				if buffs > 10 then
					TargetFrameDebuff1:SetPoint("TOPLEFT", "TargetFrameBuff11", "BOTTOMLEFT", 0, -2)
				else
					TargetFrameDebuff1:SetPoint("TOPLEFT", "TargetFrameBuff6", "BOTTOMLEFT", 0, -2)
				end
			else
				-- 6/10 buff layout
				TargetFrameBuff6:SetPoint("LEFT", "TargetFrameBuff5", "RIGHT", 3, 0)
				TargetFrameBuff7:SetPoint("TOPLEFT", "TargetFrameBuff1", "BOTTOMLEFT", 0, -2)
				TargetFrameBuff11:SetPoint("LEFT", "TargetFrameBuff10", "RIGHT", 3, 0)
				if buffs > 6 then
					TargetFrameDebuff1:SetPoint("TOPLEFT", "TargetFrameBuff7", "BOTTOMLEFT", 0, -2)
				else
					TargetFrameDebuff1:SetPoint("TOPLEFT", "TargetFrameBuff1", "BOTTOMLEFT", 0, -2)
				end
			end
		end
	end
end
